#!/bin/bash
#set -x
PATH=/home/swrhgnrj/src/chil-1.1/src:$PATH

CALTABLE=galileo_recalibration_table.txt
USER="Robin Hogan <r.j.hogan@reading.ac.uk>"

for FILE in $@
do
    cp $FILE .
    NEWFILE=$(echo $FILE | awk -F/ '{print $NF}')
    recalibrate -Zcalfile $CALTABLE -user "$USER" $NEWFILE
    addcomments -user "$USER" -var Zh "Calibration convention: in the absence of attenuation, a cloud at 273 K containing one million 100-micron droplets per cubic metre will have a reflectivity of 0 dBZ at all frequencies. In addition to the usual sources of attenuation at 94 GHz (liquid water clouds, water vapour, oxygen, melting snow and rain), it has been found that when the radomes covering the antennae of the radar become wet, they strongly attenuate the beam, typically by more than 10 dB.  Reflectivity values measured at all altitudes during rain (and shortly afterwards) should therefore not be trusted." \
	-global "It has been found that the transmitter of the Galileo radar has been losing power steadily since around September 1999. Recalibration of the entire dataset from May 1999 to October 2000 (the parameters Zh and nez) has been performed by comparing with the 3 GHz radar at Chilbolton in 13 scanning events. The 3 GHz radar is itself calibrated to better than 0.5 dB using the method of Goddard et al. (1994, Electronics Letters 30, 166-167). The resulting Galileo calibration is believed to be accurate to around 1.5 dB. It should be noted that this loss of sensitivity means that the fraction of clouds not detected by the radar will increase through the dataset." $NEWFILE
    chilncplot -system 'Chilbolton 94 GHz Cloud Radar (Galileo)' -Zrange -50 10 $NEWFILE
    gzip $NEWFILE
done
