#include "files2stdin.h"

#define BUFSIZE 4096

/* This function makes stdin behave as if the file list argv had been
 * piped into it using the unix command `cat'.  Cunning huh? */
pid_t
files2stdin(int argc, char **argv)
{
  int filedes[2];
  pid_t pid;

  pipe(filedes);

  pid = fork();
  if (pid == -1) {
    /* Fork failed */
    fprintf(stderr, "Failed to fork process\n");
    return 0;
  }
  else if (pid == 0) {
    /* In child process */
    unsigned char data[BUFSIZE];
    int iarg, fd = filedes[1];

    close(1);
    close(filedes[0]);

    for (iarg = 0; iarg < argc; ++iarg) {
      FILE *ifile;
      size_t count;
      if (!(ifile = fopen(argv[iarg], "r"))) {
	fprintf(stderr, "Warning: cannot open %s: skipping\n",
		argv[iarg]);
	continue;
      }
      while ((count = fread((void *) data, 1, BUFSIZE,
			    ifile)) > 0) {
	write(fd, data, count);
      }
      fclose(ifile);
    }
    close(fd);
    exit(0);
  }
  else {
    /* In parent process */
    close(0);
    dup2(filedes[0], 0);
    close(filedes[1]);
    return pid;
  }
}
